<?php
/*
 * Used to get user register on arcserve licensing engine
 */
class ControllerCommonGetlicense extends Controller 
{
    private $error = array();

    public function index() 
    {

        /*set the layout and template*/
        $this->id = "content";
        $this->template = "common/getlicense.tpl";
        $this->layout = "common/layout";

        /* load the request and db instances*/
        $request = Registry::get('request');
		$session = Registry::get('session');
        $db = Registry::get('db');
        $timeZoneAbbreviations = Registry::get('timeZoneAbbreviations');
		
        $this->load->model('user/user');
		
		/* check if we are super admin */
        if (isSuperAdminUser() == 1) {
		
		if(isset($_POST['mailboxinput_value']) || isset($_POST['ingestioninput_value']) || isset($_POST['dateinput_value']))   //Enters into when super admin clicks on the "Save" button.Initiated by an ajax call.
		{
			$y=0; //useful for printing the statement "Your changes are updated"
			$error="";
			if($_POST['customer_value'] == 0)
			{
				echo $this->data['str_enter_company']; exit();
			}
					
			if((!is_numeric($_POST['mailboxinput_value']) && ($_POST['mailboxinput_value']!="")) || (!is_numeric($_POST['ingestioninput_value']) && ($_POST['ingestioninput_value']!="")))
			{
				echo $this->data['text_invalid_data'];
				exit();
			}
			$m_input=$_POST['mailboxinput_value'];
			$i_input=$_POST['ingestioninput_value'];
			$c_input=$_POST['customer_value'];
			$d_input=$_POST['dateinput_value'];
			$allowed_mailboxes=0;        
            $output_mailbox = shell_exec('licUDPArchiving -q query -u -c 6AMB');
            $mailbox_status=explode("ca_license_query returned ",$output_mailbox);
			
            if(isset($mailbox_status[1]) && $mailbox_status[1]){
                $allowed_mailboxes=$mailbox_status[1];
            }
			 $allowed_historical_data_usage=0;
            $output_historical_email = shell_exec('licUDPArchiving -q query -u -c 6AHE');     
            $historical_email_status=explode("ca_license_query returned ",$output_historical_email);

            if(isset($historical_email_status[1]) && $historical_email_status[1]){
               $allowed_historical_data_usage=$historical_email_status[1];
            }
           
			$companyLicenses = $this->model_user_user->getCompanyLicenseDetails($c_input);
			$total_mail_count=$companyLicenses['mailboxtot'];
			$consumed_mail_count=$companyLicenses['mailboxcon'];
			$unlicensed_mail_count=$companyLicenses['mailboxunl'];
			$total_ingestion_count=$companyLicenses['ingestiontot'];
			$consumed_ingestion_count=$companyLicenses['ingestioncon'];
			$unicensed_ingestion_count=$companyLicenses['ingestionunl'];
			$expiry_date=$companyLicenses['expirydate'];
			$total_count=$this->model_user_user->getTotalMailboxCount();   			//Total Assigned mailbox Count to all the Companies
			$total_consumed_mail_count= ($total_count - $total_mail_count);
			$total_count_assigned=$this->model_user_user->getTotalIngestionCount();
			$total_assigned_ingestion_count=($total_count_assigned - $total_ingestion_count);
	    if(isset($d_input) && $d_input!="")
		{
			$date_format=$this->model_user_user->set_date_for_a_company($c_input,$d_input);
			$y=1;
		}
		else
		{
			if($expiry_date[0] == 0)
			{
				if($_POST['mailboxinput_value'] == "" && $_POST['ingestioninput_value'] == "" && $_POST['dateinput_value'] == "")
				{
					echo $this->data['str_enter_details'];exit();
				}
			}
			else
			{
				$this->model_user_user->set_date_for_a_company($c_input,'00-00-0000');
				$y=1;
			}
		}
		if($m_input!= "")
		{
			if($m_input >= 0)
			{
				if((($total_count - $allowed_mailboxes) > 0) && ($m_input <= ($allowed_mailboxes - $total_consumed_mail_count) || ($m_input == 0)))  //If the purchased licenses are less than the total assigned Licenses and if super admin trying to reduce his licenses to companies, then this block is triggered
			   {
				 $unlicensed_mailboxes -= ($total_mail_count - $m_input);						   // Calculates the number of unlicensed_mailboxes for superadmin.
				 $this->data['unlicensed_mailboxes'] = $unlicensed_mailboxes;
				 if($unlicensed_mailboxes < 0)
					 $unlicensed_mailboxes=0;
				 $total_mail_count=$m_input;
				 $remaining_mail_count = ($total_mail_count - $consumed_mail_count);				
				 if($remaining_mail_count < 0)
					 $remaining_mail_count = 0;
				 $unlicensed_mail_count = ($consumed_mail_count - $total_mail_count);
				 $this->model_user_user->updateLicense($total_mail_count,$remaining_mail_count,$unlicensed_mail_count,$c_input);
				 if($unlicensed_mailboxes == '0')
				 {
					$grace_period_result = $db->query("Select grace_period_start_date from " . TABLE_GLOBAL_SETTINGS . " where id = 1");
					if(isset($grace_period_result->rows[0]['grace_period_start_date']) && $grace_period_result->rows[0]['grace_period_start_date'])
			                {
			                    $db->query("UPDATE " . TABLE_GLOBAL_SETTINGS . " SET grace_period_start_date=null WHERE id=1");
			                }
				 }
				 $query = $db->query("UPDATE " . TABLE_KEY_VALUE_PAIR . " SET `key_value`=$unlicensed_mailboxes WHERE `key_name`='unlicensedCount'");
				 $y=1;
			   }
				else if($m_input <= ($allowed_mailboxes - $total_consumed_mail_count))	//To compare whether the input license is less than the remaining licenses.
				{
					if($consumed_mail_count > 0)									
					{
						if($m_input < $consumed_mail_count)							//If Super admin pulls or assigns the licenses and the "consumed" count is greater than the input license count, then some part will be unlicensed.
						{
							$total_mail_count=$m_input;
							$unlicensed_mail_count=$consumed_mail_count - $m_input;
							$remaining_mail_count=0;
						}
						else														//If the "input" mailboxcount is greater than or equal to the consumed mailbox count then unlicensed becomes '0' and the remaining will be updated
						{
							$total_mail_count=$m_input;
							$unlicensed_mail_count = 0;
							$remaining_mail_count = ($m_input - $consumed_mail_count);
						}
					}
					else															//A normal scenario where there are no consumed licenses and simply we update the total & remaining count
					{
						$total_mail_count=$m_input;
						$consumed_mail_count=0;
						$remaining_mail_count=$total_mail_count;
						$unlicensed_mail_count=0;
					}
					$this->model_user_user->updateLicense($total_mail_count,$remaining_mail_count,$unlicensed_mail_count,$c_input);
					$y=1;
				}
				else
				{
					$error.=$this->data['str_exceed_count'];
				}
			}
			else
			{
				echo $this->data['text_invalid_data'];
				exit();
			}
		}	
		if(isset($i_input) && ($i_input >= 0) && ($i_input!= ""))			//This block is for Historic ingestion
		{
		    if(($i_input <= $allowed_historical_data_usage) && ($i_input <= ($allowed_historical_data_usage - $total_assigned_ingestion_count)))
			{
					$this->model_user_user->updateIngestion($i_input,$c_input);
					$y=1;
					//echo $this->data['str_update_ingestion_license'];
					//echo $this->data['text_changes_updated'];
			}
			else
			{
					$error.=$this->data['str_exceed_count_ingestion'];
					echo $error;
					exit();
			}
		}
		if($y == 1 && $error=="")
		{
			echo "1";
			exit();
		}
		else
		{
			echo $error;
				exit();
		}
		} 
		if(isset($_POST['companyName']))	//This is to load "existing licneses" of companies.Initiated via ajax call.Whenever Super admin selects a company from "dropdown" then this block is triggered.
		{
			$x=$_POST['companyName'];
			if($x == 0)
			{
				echo "0";
				exit();
			}
			$pro=$this->model_user_user->retrieve_company_data($x);
			foreach($pro as $q)
			{
				if(($q['expirydate'] == NULL) || ($q['expirydate'][0] == 0))
				{
					$q['expirydate']= "";
				}
				else
				{
					if((DATE_FORMAT_NEW == "mm-dd-yy") || ($d_input == '00-00-0000'))
			        {
				       $date_format="m-d-Y";
			        }
			        else if(DATE_FORMAT_NEW == "yy-mm-dd")
			        {
				       $date_format="Y-m-d";
			        }
			        else
			        {
				       $date_format="d-m-Y";
			        }
					$date = DateTime::createFromFormat("Y-m-d",$q['expirydate']);
					$q['expirydate'] = $date->format($date_format);
				}
				$pro = array('name' => $q['name'], 'mt' => $q['mailboxtot'], 'mc' => $q['mailboxcon'], 'mu' => $q['mailboxunl'], 'it' => $q['ingestiontot'], 'ic' => $q['ingestioncon'], 'iu' => $q['ingestionunl'], 'exp_date'=> $q['expirydate']);
			}
			header("Content-type:application/json");
			echo json_encode($pro);
			exit();
		}
		$lang=$session->get('lang');
		
			if($lang=='en') $country='US';
			else if($lang=='pt') $country='BR';
			else if($lang=='zh') $country='CN';
			else if($lang=='zh-tr'){ $lang='zh'; $country='TW';}
			else if($lang=='ja') $country='JP';
			else if($lang=='it') $country='IT';
			else if($lang=='fr') $country='FR';
			else if($lang=='es') $country='ES';
			else if($lang=='de') $country='DE';
			else {
				$lang='en';
				$country='US';
			}
			$dateTime = new DateTime(); 
			$shortTimeZone= $dateTime->format('T');  
			$longTimeZone = $timeZoneAbbreviations[$shortTimeZone];
			
			$query =$db->query("select count(*) as count from " . TABLE_KEY_VALUE_PAIR . " where key_name='isOffline';");
			$n = $query->row['count'];
			$query =$db->query("select count(*) as count from " . TABLE_KEY_VALUE_PAIR . " where key_name='saveOffline';");
			$n1 = $query->row['count'];
			if($n>0 && $n1<=0)
			{
				$this->data['controlsDivClass'] = "hide";
				$this->data['saveOfflineDivClass'] = "show";	
				$this->data['completeOfflineDivClass'] = "hide";	
			}else if($n>0 && $n1>0)
			{
				$this->data['controlsDivClass'] = "hide";
				$this->data['saveOfflineDivClass'] = "hide";	
				$this->data['completeOfflineDivClass'] = "show";	
			}else
			{
				$this->data['controlsDivClass'] = "show";
				$this->data['saveOfflineDivClass'] = "hide";	
				$this->data['completeOfflineDivClass'] = "hide";
			}
        /*Set the title of the page*/
        $this->document->title = "<i class='fa fa-flag-checkered'></i>" . "&nbsp;<span>" . $this->data['text_get_license_heading']."</span>";
        $this->data['status']="";
		
		      
		if($_POST['Update']) $isUpdateOnly=1; 
		
		$_URL = "https://www.arcserve-register.com";
		if (file_get_contents($_URL)=="") 	$this->data['Offline']=1;
		 else 	$this->data['Offline']=0;
        if (($this->request->server['REQUEST_METHOD'] == 'POST' && $_POST['activate']) || ($this->request->server['REQUEST_METHOD'] == 'POST' && $_POST['Update']) || ($this->request->server['REQUEST_METHOD'] == 'POST' && $_POST['extend_trial']) || ($this->request->server['REQUEST_METHOD'] == 'POST' && $_POST['retry'])){
		
             if ($this->validate($isUpdateOnly) == true) {
				if($isUpdateOnly==0) {
				saveLicenseData($_POST);
				}
                
                $license_data=getLicenseData();
                $smtp_data=$this->model_user_user->getSMTPConfiguration(1);
                                
                $name=(isset($license_data['realname']) && $license_data['realname'] ? $license_data['realname'] : "''");
                $company=(isset($license_data['company']) && $license_data['company'] ? $license_data['company'] : "''");
               if($isUpdateOnly==1){
				$email=$_POST['email'];
				$license_data['email']=$email;
				}else $email=$license_data['email'];
                $contact_number=(isset($license_data['contact_number']) && $license_data['contact_number'] ? $license_data['contact_number'] : "''");
                $order_id=$license_data['order_id'];
                $unique_id=$license_data['instance_uniq_id'];
                $netsuitid=$license_data['netSuiteId'];
				$terms_privacy='FALSE';
				if (isset($this->request->post['terms_privacy'])) {
					$terms_privacy='TRUE';
				}
				if($isUpdateOnly==1) saveLicenseData($license_data);
                $host_name=(isset($smtp_data[0]['web_url']) && $smtp_data[0]['web_url'] ? $smtp_data[0]['web_url'] : "''");
               
			if($this->request->server['REQUEST_METHOD'] == 'POST' && $_POST['extend_trial'])
			{
				$isActivateTrialMode='true';
				$order_id="''";
				$netsuitid="''";
			}else 
			{
			$isActivateTrialMode='false';
			}
		
 			    if (file_get_contents($_URL)=="") 
				{
					$status_message=$this->data['str_label_connection_not_live'];
					$db->query("UPDATE " . TABLE_GLOBAL_SETTINGS . " SET network_status_message=?  WHERE id=?", array("$status_message", 1));//registerOffline deActivateOffline 
					
					$this->data['controlsDivClass'] = "hide";
					$this->data['saveOfflineDivClass'] = "show";	
					$this->data['completeOfflineDivClass'] = "hide";					
					$query =$db->query("select count(*) as count from " . TABLE_KEY_VALUE_PAIR . " where key_name='isOffline';");
					$n = $query->row['count'];
					if($n==0) $db->query("INSERT INTO " . TABLE_KEY_VALUE_PAIR . " (key_name, key_value) VALUES('isOffline','true');");					
				}else{
					$db->query("delete from " . TABLE_KEY_VALUE_PAIR . " key_name='saveOffline';");
					$db->query("delete from " . TABLE_KEY_VALUE_PAIR . " key_name='isOffline';");
					$db->query("UPDATE " . TABLE_GLOBAL_SETTINGS . " SET network_status_message=?  WHERE id=?", array("", 1));
					
					$this->data['controlsDivClass'] = "show";
					$this->data['saveOfflineDivClass'] = "hide";
					$this->data['completeOfflineDivClass'] = "hide";
					$url_register="https://www.arcserve-register.com:443/AERPServer/customerWebService/registerV62"; 
					if($isUpdateOnly==1) $url_register = "https://www.arcserve-register.com:443/AERPServer/customerWebService/updateCustomerDetailsV62"; 
					$data_register="{  
								'name':'$name',
								'company':'$company',
								'emailID':'$email',
								'contactNumber':'$contact_number',
								'orderID':$order_id,
								'netSuiteId':$netsuitid,
								'locale_language':$lang,
								'locale_country':$country,
								'udpServerID':$unique_id,
								'hostName':$host_name,
								'productType':'Arcserve UDP Archiving',
								'isPIP':$terms_privacy,
								'isActivateTrialMode':$isActivateTrialMode,
								'timeZone':'$longTimeZone',
								'licenseMode':'Online'
							}";
					WriteIntoTagsLog("data_register".$data_register);
					$response_register=do_post_request($url_register, $data_register, $optional_headers = null);
                                        WriteIntoTagsLog("response_register".$response_register);
					$response_register=json_decode($response_register);                
                                
					if($isUpdateOnly==0)			
					{
						if(isset($response_register->responseCode) && ($response_register->responseCode =='REGISTRATION_FAILED_VERSION_6.5_MISMATCH' || $response_register->responseCode == 'REGISTRATION_FAILED_SALESORDERITEMS_EMPTY' || $response_register->responseCode == 'REGISTRATION_FAILED_ORDERID_MISMATCH')){
							$this->data['status'] = $response_register->responseCode;
					}else if($response_register->responseCode == 'REGISTRATION_SUCCESS' || $response_register->responseCode == 'REGISTRATION_AUTHORIZATION_REQUIRED'){
						$db = Registry::get('db');
						 	$db->query("UPDATE " . TABLE_GLOBAL_SETTINGS . " SET license_registration_status=1, licenseMode='Online', trialMode='". $isActivateTrialMode  ."' WHERE id=1;");
					}else if($response_register->responseCode == 'UDP_SERVER_ENTITLEMENT_EXISTS'){
						$this->data['status'] = "UDP_SERVER_ENTITLEMENT_EXISTS";
					}else{
						$this->data['status'] = $this->data['str_label_issue_with_licensing_portal'];
					}
					
					$license_data=getLicenseData();
					$this->data['post'] = $license_data;
					
						if($this->data['status'] == ''){
							$this->data['successstringlabel'] = $this->data['str_label_success']; //"Register Success"
							$this->data['successstring'] = $this->data['str_label_activation_complete'];
							if( $response_register->responseCode == 'REGISTRATION_AUTHORIZATION_REQUIRED' ){
								 $this->data['successstringlabel'] = $this->data['str_label_success']; //"Register Success"
								 $this->data['successstring'] = $this->data['text_str_license_waiting_for_approval'];//$response_register->result;
							 }
						}
					}else if($isUpdateOnly==1)
					{
						//UPDATECUSTOMERDETAILS_SUCCESS
					    if(isset($response_register->responseCode) && ($response_register->responseCode == 'UPDATECUSTOMERDETAILS_FAILED' || $response_register->responseCode == 'REGISTRATION_FAILED_ORDERID_MISMATCH')){
								$this->data['status'] = $response_register->responseCode;
						}else if($response_register->responseCode == 'UPDATECUSTOMERDETAILS_SUCCESS'){
							//	$db = Registry::get('db');
							//	$db->query("UPDATE " . TABLE_GLOBAL_SETTINGS . " SET license_registration_status=?  WHERE id=?", array(1, 1));
						}
						if($this->data['status'] == ''){
								$this->data['successstringlabel'] = $this->data['str_label_updation_success']; //"Update Success"
								$this->data['successstring'] =$this->data['str_label_upgradation_done'];// $response_register->result;
						}
						
						$license_data=getLicenseData();
						$this->data['post'] = $license_data;
					
					}
			  }
			}else{
                $this->data['errorstring'] = $this->data['text_error_message'];
                $this->data['errors'] = $this->error;
                $this->data['post'] = $_POST;
            }
		}
		if ($this->request->server['REQUEST_METHOD'] == 'POST' && $_POST['saveOffline']) {
				$license_data=getLicenseData();
				$smtp_data=$this->model_user_user->getSMTPConfiguration(1);                                
                $name=(isset($license_data['realname']) && $license_data['realname'] ? $license_data['realname'] : "''");
                $company=(isset($license_data['company']) && $license_data['company'] ? $license_data['company'] : "''");
                $email=$license_data['email'];
                $contact_number=(isset($license_data['contact_number']) && $license_data['contact_number'] ? $license_data['contact_number'] : "''");
                $order_id=$license_data['order_id'];
                $unique_id=$license_data['instance_uniq_id'];
                $netsuitid=$license_data['netSuiteId'];
				$host_name=(isset($smtp_data[0]['web_url']) && $smtp_data[0]['web_url'] ? $smtp_data[0]['web_url'] : "''");
				$terms_privacy='false';
				if (isset($this->request->post['terms_privacy'])) {
					$terms_privacy='true';
				}
				$isActivateTrialMode='false';
				if($order_id=="" && $netsuitid=="")	$isActivateTrialMode='true';
				
				$this->saveRegistrationDetails($netsuitid, $unique_id, $order_id, $email, $name, $company, $contact_number, $terms_privacy, $lang, $country, $longTimeZone, $host_name, $isActivateTrialMode, 'registerOffline');
				$this->data['controlsDivClass'] = "hide";
				$this->data['saveOfflineDivClass'] = "hide";
				$this->data['completeOfflineDivClass'] = "show";
				$query =$db->query("select count(*) as count from " . TABLE_KEY_VALUE_PAIR . " where key_name='saveOffline';");
				$n = $query->row['count'];
				if($n==0) $db->query("INSERT INTO " . TABLE_KEY_VALUE_PAIR . " (key_name, key_value) VALUES('saveOffline','true');");	
				$db->query("UPDATE " . TABLE_GLOBAL_SETTINGS . " SET license_registration_status=1, licenseMode='Offline', trialMode='". $isActivateTrialMode  ."' WHERE id=1;");
		}
		if ($this->request->server['REQUEST_METHOD'] == 'POST' && $_POST['deactivate']) {
		$license_data=getLicenseData();
                $email=$license_data['email'];
                $order_id=$license_data['order_id'];
                $unique_id=$license_data['instance_uniq_id'];
                $netsuitid=$license_data['netSuiteId'];
                
                $url_deactivate="https://www.arcserve-register.com/AERPServer/customerWebService/deActivateProductActivationV62"; 
                $data_deactivate="{ 
                            'emailID':$email,
                            'orderID':$order_id,
                            'netSuiteId':$netsuitid,
                            'udpServerID':$unique_id,
                            'productType':'Arcserve UDP Archiving',
                            'licenseMode':'Online'
                        }";
						
						
				$response_deactivate=do_post_request($url_deactivate, $data_deactivate, $optional_headers = null);
                $response_deactivate=json_decode($response_deactivate);                
                                
                if(isset($response_deactivate->responseCode) && ($response_deactivate->responseCode == 'DEACTIVATELICENSE_FAILED_LICENSESTATUS_INACTIVE' || $response_deactivate->responseCode == 'DEACTIVATELICENSE_FAILED_EXCEPTION')){
                    $this->data['status'] = $response_deactivate->responseCode;
                }else if($response_deactivate->responseCode == 'DEACTIVATELICENSE_SUCCESS'){
                    $db = Registry::get('db');
                    $db->query("UPDATE " . TABLE_GLOBAL_SETTINGS . " SET license_registration_status=?  WHERE id=?", array(0, 1));
					$db->query("UPDATE " . TABLE_GLOBAL_SETTINGS . " SET deactivated_date=?  WHERE id=?", array( date("Y-m-d 00:00:00"), 1));
					system("sudo rm /opt/Arcserve/lic/arcserve.olf");
					
                }else{
                    $this->data['status'] = $this->data['str_label_issue_with_licensing_portal'];
                }
                
                $license_data=getLicenseData();
                $this->data['post'] = $license_data;
                if($this->data['status'] == ''){
					$this->data['successstringlabel'] = $this->data['str_label_deactivation_success']; //"Deactivation Success"
                    $this->data['successstring'] = $this->data['str_label_deactivation_complete'];
                }
        }else{
            $license_data=getLicenseData();
            $this->data['post'] = $license_data;
        }
		
			if(Registry::get('hosted_service')==1) {
				 $this->data['activateStatus']= "";    
			}else $this->data['activateStatus']= $this->isActivated();  
		
        // Start Total purchased counters
            $allowed_mailboxes=0;        
            $output_mailbox = shell_exec('licUDPArchiving -q query -u -c 6AMB');
            $mailbox_status=explode("ca_license_query returned ",$output_mailbox);

            if(isset($mailbox_status[1]) && $mailbox_status[1]){
                $allowed_mailboxes=$mailbox_status[1];
            }
            $this->data['allowed_mailboxes'] = $allowed_mailboxes;
            $assigned_mailboxes=$this->model_user_user->getTotalMailboxCount();
			$assigned_ingestion=$this->model_user_user->getTotalIngestionCount();
			if($assigned_mailboxes == "" || $assigned_ingestion == "")
			{
				$assigned_ingestion = 0;
				$assigned_mailboxes = 0;
			}
			$this->data['assigned_mailboxes']= $assigned_mailboxes;		
			$this->data['assigned_ingestion']= $assigned_ingestion;
            $allowed_historical_data_usage=0;
            $output_historical_email = shell_exec('licUDPArchiving -q query -u -c 6AHE');     
            $historical_email_status=explode("ca_license_query returned ",$output_historical_email);

            if(isset($historical_email_status[1]) && $historical_email_status[1]){
               $allowed_historical_data_usage=$historical_email_status[1];
            }
            $this->data['allowed_historical_data_usage'] = $allowed_historical_data_usage;
        // End total purchased counters
        
        // Start Total Used Counter
            $used_mailboxes=getMailBoxCounter();
            $used_hdu=getHistoricEmailIngestionPerGbCounter();
        // End Total Used Counter
        
        // Start Remaining counters
            $remaining_mailboxes=$allowed_mailboxes-$assigned_mailboxes;
            $remaining_hdu=$allowed_historical_data_usage-($used_hdu/1000000);
      // $remaining_hdu=$allowed_historical_data_usage - $assigned_ingestion;
            if($remaining_mailboxes < 0){
                $this->data['remaining_mailboxes']=0;
            }else{
                $this->data['remaining_mailboxes']=$remaining_mailboxes;
            }

            if($remaining_hdu < 0){
                $this->data['remaining_hdu']=0;
            }else{
                $remaining_hdu=number_format($remaining_hdu,6);
                $this->data['remaining_hdu']= $this->truncate_number($remaining_hdu);
            }
        // End Remaining counters
        
        // Start unlicensed counters
            $unlicensed_mailboxes=0;
            if(($assigned_mailboxes - $allowed_mailboxes) > 0){  //Suddenly if the portal returned the "total" count less than the "assigned"count or if part of the licenses are expired.
				$remaining_mailboxes=0;
				$this->data['remaining_mailboxes']=$remaining_mailboxes;
                $unlicensed_mailboxes=$assigned_mailboxes-$allowed_mailboxes;
            }
			elseif( LICENSE_STATUS == 'TRIAL_PERIOD' || LICENSE_STATUS == 'EXTEND_TRIAL_PERIOD' || LICENSE_STATUS =='TRIAL_EXPIRED')
			{
				/*if((LICENSE_STATUS != 'EXTEND_TRIAL_PERIOD') && $assigned_mailboxes == 0)
				{
					$this->data['assigned_mailboxes']=$used_mailboxes;
				}*/
				if(($used_mailboxes - $allowed_mailboxes) > 0){
                $unlicensed_mailboxes=$used_mailboxes-$allowed_mailboxes;
				$remaining_mailboxes=0;
             }
			 else
			 {
				$remaining_mailboxes=$allowed_mailboxes-$used_mailboxes;
				$unlicensed_mailboxes=0;
				if($remaining_mailboxes < 0)
					$remaining_mailboxes =0;
			 }
			}
            $this->data['unlicensed_mailboxes']=$unlicensed_mailboxes;

            $unlicensed_hdu=0;
            if((($used_hdu/1000000) - $allowed_historical_data_usage) > 0){
                $unlicensed_hdu=($used_hdu/1000000) - $allowed_historical_data_usage;

                $unlicensed_hdu=  number_format($unlicensed_hdu,6);
                $unlicensed_hdu=$this->truncate_number($unlicensed_hdu);

            }
            $this->data['unlicensed_hdu']=$unlicensed_hdu;
        // End unlicensed counters
		$profilesList=$this->model_user_user->getLicenseDetails();
        $this->data['profilesList']=$profilesList;                       // To display the license details of each company
		$this->data['customers']=$this->model_user_user->get_customers();//To display the list of customers in the pop up window of "Assign Licenses"
		} else {
            $this->template = "common/error.tpl";
            $this->data['errorstring'] = $this->data['text_you_are_not_super_admin'];
        }
        $this->render();
    }
    private function truncate_number( $number) {
        $pos = strpos($number,'.');
        if ($pos === false){
            return $number;
        }else{
            $before_decimal=$this->strbefore($number,'.');
            $after_decimal=$this->strafter($number,'.');

            return $before_decimal.$after_decimal;
        }
    }
    private function validate($isUpdateOnly) 
    {
        //email address is required and must be in the proper format
        if (!isset($this->request->post['email']) || strlen($this->request->post['email']) < 3) {
            $this->error['email'] = $this->data['text_invalid_email'];
        } else {
            $emails = explode("\n", $this->request->post['email']);
            foreach ($emails as $email) {
                $email = strtolower(rtrim($email));
                if ($email == '') {
                    continue;
                }

                $ret = checkemail($email, $this->domains);
                if ($ret == 0) {
                    $this->error['email'] = $this->data['text_invalid_email'] . ": *$email*";
                } /*else if ($ret == -1) {
                    $this->error['email'] = $this->data['text_email_in_unknown_domain'] . ": *$email*";
                }*/
            }
        }
        if($isUpdateOnly==0)
		{ 
			//primary domain is required
			/*if (isset($this->request->post['realname']) && $this->request->post['realname'] == '') {
				$this->error['realname'] = $this->data['text_missing_data'];
			}*/
			if($this->request->server['REQUEST_METHOD'] == 'POST' && $_POST['extend_trial']){
			}else
			{
				//primary domain is required
				if (isset($this->request->post['order_id']) && $this->request->post['order_id'] == '') {
					$this->error['order_id'] = $this->data['text_missing_data'];
				}
				
				//primary domain is required
				if (isset($this->request->post['netSuiteId']) && $this->request->post['netSuiteId'] == '') {
					$this->error['netSuiteId'] = $this->data['text_missing_data'];
				}
			}

        //primary domain is required
        if (!isset($this->request->post['terms'])) {
            $this->error['terms'] = $this->data['text_field_required'];
        }
}
        //primary domain is required
       /*  if (!isset($this->request->post['terms_privacy'])) {
            $this->error['terms_privacy'] = $this->data['text_field_required'];
        } */

        
        if (!$this->error) {
            return true;
        } else {
            return false;
        }
    
    }
    private function strafter($string, $substring) {
        $pos = strpos($string, $substring);
        $decimal_values=substr($string, $pos+strlen($substring));
        
        if(strlen($decimal_values) > 3){
            if($decimal_values > 1){
                $return_value = substr($decimal_values, 0, 6);
            }else{
                return "";
            }
            
        }else{
            $return_value = $decimal_values;
        }
        
        return ".".$return_value;
    }
    private function strbefore($string, $substring) {
        $pos = strpos($string, $substring);
        return(substr($string, 0, $pos));
    }
 private function isActivated() {
		
		$_URL = "https://www.arcserve-register.com";
		$db = Registry::get('db');
        $query = $db->query("SELECT * FROM " . TABLE_GLOBAL_SETTINGS . " WHERE id=?", array(1));
       	if (file_get_contents($_URL)=="") 
        {
            $status_message=$this->data['str_label_connection_not_live'];
            $db->query("UPDATE " . TABLE_GLOBAL_SETTINGS . " SET network_status_message=?  WHERE id=?", array("$status_message", 1));
            return $this->data['str_label_connection_not_established'];
        }else{
 		    $db->query("UPDATE " . TABLE_GLOBAL_SETTINGS . " SET network_status_message=?  WHERE id=?", array("", 1));
			
            if(isset($query->row['instance_uniq_id']) && $query->row['instance_uniq_id'] && $query->row['license_registration_status']!=2){
                $email=$query->row['email_address'];
                $netsuitid=$query->row['netsuitid'];
                $unique_id=$query->row['instance_uniq_id'];

				$isActivateTrialMode='true';
				if(isset($query->row['netsuitid']) && $query->row['netsuitid'] && isset($query->row['order_id']) && $query->row['order_id']) $isActivateTrialMode='false';
				else $netsuitid="''";
				
                $url_isactivated="https://www.arcserve-register.com:443/AERPServer/customerWebService/isActivatedV62";
                $data_isactivated="{
                    'isActivateTrialMode':$isActivateTrialMode,
                    'netSuiteId':$netsuitid,
                    'emailID':$email,
                    'udpServerId':$unique_id,
                    'productType':'Arcserve UDP Archiving'
                }";

                $response_isactivated=do_post_request($url_isactivated, $data_isactivated, $optional_headers = null);
                $response_isactivated=json_decode($response_isactivated);

                if(isset($response_isactivated->responseCode) && $response_isactivated->responseCode == 'ISACTIVATED_NOTREGISTERED'){
                    return $this->data['str_label_product_not_register'];
                    exit;
                }else if($response_isactivated->responseCode  == 'ISACTIVATED_INACTIVE'){
				
                  //  return $this->data['str_label_product_not_activated'];
				    return $response_isactivated->responseCode;
                    exit;
                }else if($response_isactivated->responseCode  == 'ISACTIVATED_ACTIVE'){
					return $response_isactivated->responseCode;
                    exit;
				}
    }
	}
	}
function saveRegistrationDetails($netSuiteId, $udpServerID, $orderID, $emailID, $name, $company, $contactNumber, $isPIP, $locale_language, $locale_country, $timeZone, $hostName, $isActivateTrialMode, $serviceInvoke_name){
		system("mkdir /var/fas/www/Offline");
		system("chmod 777 /var/fas/www/Offline*");
		
		$offlineFileName = "/var/fas/www/Offline/offline.arc";		
		system("sudo rm ".$offlineFileName);
		
		$db = Registry::get('db');
        $query = $db->query("SELECT UUID() as UUID ;");
		$UUID=$query->row['UUID'];
        $file = fopen($offlineFileName, "wb") or exit("Unable to openfile!");
        if(udpServerID != null)
			{
				fwrite($file , "REGISTER_NETSUITEID = ". $netSuiteId . PHP_EOL);
				fwrite($file , "REGISTER_UDPSERVERID = ". $udpServerID . PHP_EOL);
				fwrite($file , "REGISTER_UDPSERVERID_OLD = ". $udpServerID . PHP_EOL);
				fwrite($file , "REGISTER_EMAILID = ". $emailID . PHP_EOL);
				fwrite($file , "REGISTER_COMPANY = ". $company . PHP_EOL);
				fwrite($file , "REGISTER_NAME = ". $name . PHP_EOL);
				fwrite($file , "REGISTER_CONTACT = ". $contactNumber . PHP_EOL);
				fwrite($file , "REGISTER_ORDERID = ". $orderID . PHP_EOL);				
				fwrite($file , "REGISTER_OFFLINE_UNIQUEID = ". $UUID . PHP_EOL);
				fwrite($file , "ISUPLOAD_TOCLOUD = ". $isPIP . PHP_EOL);
				fwrite($file , "REGISTER_LOCALE_LANGUAGE = ". $locale_language . PHP_EOL);
				fwrite($file , "REGISTER_LOCALE_COUNTRY = ". $locale_country . PHP_EOL);
				fwrite($file , "REGISTER_TIMEZONE = ". $timeZone . PHP_EOL);
				fwrite($file , "REGISTER_PRODUCTTYPE = Arcserve UDP Archiving". PHP_EOL);
				fwrite($file , "REGISTER_LICENSEMODE = offline". PHP_EOL);
				fwrite($file , "REGISTER_HOSTNAME = ". $hostName . PHP_EOL);
				fwrite($file , "REGISTER_TRIALMODE = ". $isActivateTrialMode . PHP_EOL);	
				fwrite($file , "SERVICEINVOKE_NAME = ". $serviceInvoke_name . PHP_EOL);					
			}
			fclose($file);
			
			$db->query("UPDATE " . TABLE_GLOBAL_SETTINGS . " SET register_offline_uniqueid=? WHERE id=?", array($UUID, 1));
	}
}

?>
